# -*- coding: utf-8 -*-
# Algorithmus_von_Kruskal_Schritte.py
# basiert auf Algorithmus-von-Kruskal-2020.py

from Graphenprojekt import *
cont=Controller()

graph=cont.gibKantenDict()
##print(graph)

## Kanten: [<knoten-1>, <knoten-2>, <bewertung>]
def alleKanten():
    kanten=[]
    for knoten in graph:
        nachfolger=graph[knoten]
        for nach in nachfolger:
            kanten+=[[knoten]+nach]
    return kanten

kanten=alleKanten()
#print(kanten)

### ===== Funktionen zum Sortieren
# ----- kuerzer -----
def kuerzer(kante1, kante2):
    return  (kante1[2] < kante2[2])

# ----- ordneKanten -----
# bei Kruskal nur einmal am Anfang, daher also keine PrioWS
# sondern shclicht Sortieren durch Einfuegen
def ordneKanten(kanten):
    sortierte=[]
    for kante in kanten:
        sortierte=ordneEin(kante, sortierte)
    return sortierte

# ----- ordneEin -----
# sortiert durch Einfuegen
def ordneEin(kante, sortierte):
    for index in range(len(sortierte)):
        if kuerzer(kante, sortierte[index]):
            sortierte[index:index]=[kante]
            return sortierte
    sortierte[len(sortierte):len(sortierte)]=[kante]
    return sortierte

### ===== Teilbaeume initialisieren =====
# ----- erzeugeTeilbaeume -----
# erzeugt den Anfangszustand aus der Kantenliste
def erzeugeTeilbaeume(kanten):
    alleKnoten=gibAlleKnoten(kanten)
    teilbaeume=[]
    for knoten in alleKnoten:
        teilbaeume.append([[knoten],[]])
    return teilbaeume

def gibAlleKnoten(kanten):
    alleKnoten=[]
    for kante in kanten:
        if not(kante[0] in alleKnoten):
            alleKnoten.append(kante[0])
        if not(kante[1] in alleKnoten):
            alleKnoten.append(kante[1])
    return alleKnoten

### ===== Funktionen fuer die Schritte =====        
# ----- knotenImTeilbaum -----
# prueft, ob ein knoten in einem teilbaum enthalten ist
def knotenImTeilbaum(knoten, teilbaum):
    return teilbaum[0].count(knoten)==1

# ----- posTeilbaumZuKnoten -----
# gibt zu einem Knoten die Position des Teilbaums in der
# Teilbaumliste zurueck, die den Knoten enthaelt
def posTeilbaumZuKnoten(knoten, teilbaeume):
    for teilbaum in teilbaeume:
        if knotenImTeilbaum(knoten, teilbaum):
            return teilbaeume.index(teilbaum)
  
# ----- verbinde -----
# verbindet die beiden Teilbaeume durch die Kante.
def verbinde(kante, erster, zweiter, alleTeilbaeume):
    tb1,tb2=alleTeilbaeume[erster],alleTeilbaeume[zweiter]
    neu=[ tb1[0]+tb2[0], [kante]+tb1[1]+tb2[1] ]    
    alleTeilbaeume.remove(tb1)
    alleTeilbaeume.remove(tb2)
    alleTeilbaeume.append(neu)
    return alleTeilbaeume

def entferneRueckKante(kante, kanten):
    for andere in kanten:
        if kante[0]!=andere[1]: return kanten
        if kante[1]!=andere[0]: return kanten
        else:
            kanten.remove(andere)
    return kanten

# ----- kruskal -----
def kruskalSchritt(kanten,teilbaeume):
    if len(kanten)==0:
        print('\nfertig!\n',teilbaeume[0][1])
        return [],teilbaeume
    kante=kanten[0]
    erster=posTeilbaumZuKnoten(kante[0], teilbaeume)
    zweiter=posTeilbaumZuKnoten(kante[1], teilbaeume)        
    if erster!=zweiter:
        teilbaeume=verbinde(kante, erster, zweiter, teilbaeume)
        cont.aendereFuellFarbe(Knoten, kante[0], 'red')
        cont.aendereFuellFarbe(Knoten, kante[1], 'red')
        cont.aendereRandFarbe(Kante, kante[0], 'red', kante[1])
        if len(teilbaeume)==1:
            return [],teilbaeume
    else:
        print('Zyklus / Rueckkante bei ', kante)
    ## Rueckkante raus, klappt nur, wenn Reihenfolge stimmt
    if len(kanten)>1:
        if (kante[0]==kanten[1][1]) and (kante[1]==kanten[1][0]):
            return kanten[2:],teilbaeume
    return kanten[1:],teilbaeume

### Initialisierung
kanten=ordneKanten(kanten)
teilbaeume=erzeugeTeilbaeume(kanten)
### Aufruf von
##kanten,teilbaeume=kruskalSchritt(kanten,teilbaeume)
print('wiederholt eingeben:')
print('kanten,teilbaeume=kruskalSchritt(kanten,teilbaeume)')
