from Graphenprojekt.leinwand import Leinwand
import tkinter as tk
class Kante:
    """
    Stellt eine Kante dar.
    """

    fg,bg = 'black','white'
    def dunkelModus():
        Kante.fg,Kante.bg = 'white','black'
    def hellModus():
        Kante.fg,Kante.bg = 'black','white'

    def __init__(self,vonKnoten,nachKnoten,beschriftung=''):
        """
        Erzeugt einen Tisch an der gegebenen Position.
        xPosition: die x-Koordinate der Mitte des Tischs
        yPosition: die y-Koordinate der Mitte des Tischs
        farbe: die Farbe, in der der Tisch angezeigt werden soll.
               Dies sollte einer der Farbnamen der Klasse Farben sein.  
        """
        self.vonKnoten = vonKnoten
        self.nachKnoten = nachKnoten
        self.beschriftung = beschriftung
        self.xVon,self.yVon = vonKnoten.gibMitte()
        self.xNach,self.yNach = nachKnoten.gibMitte()
        self.farbe = Kante.fg
        self.formen = []
        self.leinwand = Leinwand()

    def gibKnoten(self):
        return self.vonKnoten,self.nachKnoten

    def gibKnotenNamen(self):
        return self.vonKnoten.gibNamen(),self.nachKnoten.gibNamen()

    def zeige(self):
        """
        Zeigt diese Kante.
        """
        if not self.formen:
            dieKante = self.leinwand.linie(self.xVon,self.yVon,
                                           self.xNach,self.yNach,
                                           width=2,fill=self.farbe)
            self.formen.append(dieKante)
            xText,yText = (self.xVon+self.xNach)/2,(self.yVon+self.yNach)/2
            beschriftung = self.leinwand.text(xText,yText,
                                              self.beschriftung,fill=self.farbe,
                                              font=('Helvetica',12,'bold'),
                                              anchor=tk.NW)
            self.formen.append(beschriftung)
            ## Linienenden ueberdecken:
            self.vonKnoten.verberge()
            self.vonKnoten.zeige()
            self.nachKnoten.verberge()
            self.nachKnoten.zeige()

    def verberge(self):
        """ Entfernt diese Kante aus der Ansicht. """
        for form in self.formen:
            self.leinwand.loesche(form)
        self.formen = []

    def aendereRandFarbe(self,neueFarbe):
        """ aendert die Randfarbe der Kante"""
        self.verberge()
        self.farbe = neueFarbe
        self.zeige()
        
